C+    add_to_failure_list.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM MAKES A SUITABLE RECORD FOLLOWING A 
C+    CONVERGENCE FAILURE DURING THE CALCULATION OF THE 
C+    EIGENVALUE SPECTRUM.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*1 ACONV(4)
      DATA ACONV/'1','2','3','4'/
      CALL GINFO(INFO)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''Which auto run (1,2,3 or 4) ???'')')
      READ(5,*)IWHICH
      WRITE(66,'(''THE ENTERED VALUE IS: '',I2)')IWHICH
      CLOSE(66)
      CALL IOUT(INFO,'minor')
      OPEN(11,FILE='data_files/failure.count'//ACONV(IWHICH)
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NCONV
      CLOSE(11)
      OPEN(11,FILE='data_files/failure.count'//ACONV(IWHICH)
     &,STATUS='OLD')
      WRITE(11,'(I6)')(NCONV+1)
      CLOSE(11)
      OPEN(12,FILE='data_files/failure.list'//ACONV(IWHICH)
     &,STATUS='OLD')
      REWIND(12)
      DO 200 I=1,10000
         READ(12,*,END=201)DUMMY
 200  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(
     &     ''ERROR: LOOP 200 FINISHED IN add_to_failure_list.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      BACKSPACE(12)
      OPEN(13,FILE='../temp_files/control_parameters.data'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPNEW
      READ(13,*)CNEW
      CLOSE(13)
      OPEN(14,FILE='data_files/spectrum.evalue'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)EVRNEW,EVINEW
      CLOSE(14)
      WRITE(12,9000)PPNEW,CNEW,EVRNEW,EVINEW,IWHICH
      CLOSE(12)
      CALL ISTOP(INFO)
 9000 FORMAT(2E18.10E2,2E16.8E2,I2,
     &     '  ctrl speed evalr evali stage(=1/2/3/4)')
      END
