C+    extracthopf_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM WRITES A SCRIPT THAT EDITS extracthopf.f,
C+    SETTING APPROPRIATE ARRAY DIMENSIONS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION IARRAY(9)
      CALL GINFO(INFO)
      OPEN(12,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)NPDE
      READ(12,*)NPTW
      CLOSE(12)
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      CLOSE(12)
      OPEN(13,FILE='../temp_files/extracthopf_prepare.script'
     &,STATUS='NEW')
      WRITE(13,9000)NPTW,(4*NTST+1),(5*NPTW+1)
      CLOSE(13)
      CALL ISTOP(INFO)
 101  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: premature end of file 12'',
     &     '' in extracthopf_prepare.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
      CALL ISTOP(INFO)
 9000 FORMAT('#!/bin/sh',/,
     &     'rm -f ../spectrum/extracthopf_editted.f',/,
     &     'sed -e ''1s/extracthopf/extracthopf_editted/'' ',
     &     ' -e ''s/PARAMETER(NPTW=.*)/PARAMETER(NPTW=',
     &     I4,')/g'' ',
     &     ' -e ''s/PARAMETER(NPTS=.*)/PARAMETER(NPTS=',
     &     I8,')/g'' ',
     &     ' -e ''s/9000 FORMAT(.*/9000 FORMAT(',
     &     I5,'E18.10E2)/'' ',
     &     ' ../spectrum/extracthopf.f >',
     &     ' ../spectrum/extracthopf_editted.f')
      END
